<template>
  <v-card>
    <v-tabs
      background-color="primary--darken-1"
      center-active
      dark
    >
      <v-tab>
        Seleccionar pedidos ({{ orders.length }})
      </v-tab>

      <v-tabs-slider color="primary" />

      <v-tab-item :key="1">
        <v-data-table
          :loading="loading"
          :headers="headers"
          :items="readyOrders"
          show-select
          dense
          @input="handleSelect"
        >
          <template #item.units="{ item }">
            {{ item.toSendUnits }}
          </template>

        </v-data-table>
      </v-tab-item>
    </v-tabs>
  </v-card>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { errorOptions } from '~/helpers/toast';
import { hashId } from '~/helpers/format/ids';
import { READY } from '~/services/sync/order-status';

export default {
  name: 'SelectOrders',
  emit: ['select'],
  data: () => ({
    name: '',
    orders: [],
    loading: false,
    headers: [
      { text: 'Nª', align: 'start', sortable: true, value: 'id' },
      { text: 'Cliente', sortable: true, value: 'client.businessName' },
      { text: 'Unidades (pallets)', sortable: true, value: 'units', align: 'center' },
    ],
  }),
  computed: {
    ...mapState({
      all: state => state.sync.orders.all,
    }),
    readyOrders() {
      return this.all[READY];
    },
  },
  async mounted() {
    await this.getAllReadyOrders();
  },
  methods: {
    hashId,
    ...mapActions({
      getAllOrders: 'sync/orders/getAllOrders',
    }),
    handleSelect(orders) {
      this.orders = orders;
      this.$emit('select', { orders });
    },
    async getAllReadyOrders() {
      try {
        this.loading = true;
        await this.getAllOrders({ state: READY });
      } catch (e) {
        this.$toast.error('No se ha podido obtener los pedidos listos para programar', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
